/* Generated by Together */

package ap.data;

/**
 * Title:        Ametas StockService
 * Description:  Basisklasse fr die Beschreibung von Aktien
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class CBaseStock implements java.io.Serializable {

	/** Einige Membervariablen der Klasse (protected, damit erbende Klassen
	Zugriff auf die Variablen haben */
	protected String m_sName;
	protected double m_dPriceCurrent = 0.0;
	protected double m_dPriceIPO = 0.0;



	/**
	 * Konstruktor der Klasse, mit dem alle Membervariablen gesetzt werden knnen
	 *
	 * @param sName Das Namensattribut des anzulegenden Objekts
	 * @param dPriceCurrent Der aktuelle Preis des anzulegenden Objekts
	 * @param dPriceIPO Das Erffnungspreis des anzulegenden Objekts
	 */
	public CBaseStock (String sName, double dPriceCurrent, double dPriceIPO) {

		/* Die Parameter in die Membervariablen eintragen */
		m_sName = sName;
		m_dPriceCurrent = dPriceCurrent;
		m_dPriceIPO = dPriceIPO;

	}

	/**
	 * Konstruktor der Klasse, mit dem alle Membervariablen 0 bzw. null bleiben
	 */
	public CBaseStock () {

		/* In diesem Konstruktorcode passiert gar nichts, alle Membervariablen
		behalten ihre initalien Werte (null bei Objekten, 0 bei Grunddatentypen) */

	}

	/**
	 * Liefert den Wert der Membervariable m_sName zurck, die den Namen des
	 * DepotEntrys, also den Aktiennamen enthlt.
	 *
	 * @return Der Name des DepotEintrags (Aktienname) als String
	 */
	public String getName () {
		return m_sName;
	}

	/**
	 * Setzt den Wert der Membervariable m_sName, die den Namen des
	 * DepotEntrys, also den Aktiennamen aufnimmt.
	 *
	 * @param sName Der neue Name des DepotEintrags
	 */
	public void setName (String sName) {
		m_sName = sName;
	}

	/**
	 * Liefert den Wert der Membervariable m_dPriceCurrent zurck, die den
	 * altuellen Preis des DepotEntrys enthlt.
	 *
	 * @return Der aktuelle Preis des DepotEintrags als double
	 */
	public double getPriceCurrent () {
		return m_dPriceCurrent;
	}

	/**
	 * Setzt den Wert der Membervariable m_dPriceCurrent, die den
	 * altuellen Preis des DepotEntrys aufnimmt.
	 *
	 * @param dPriceCurrent Der neue, aktuelle Preis des DepotEintrags
	 */
	public void setPriceCurrent (double dPriceCurrent) {
		m_dPriceCurrent = dPriceCurrent;
	}

	/**
	 * Liefert den Wert der Membervariable m_dPriceIPO zurck, die den
	 * "Emmissionskurs" des DepotEntrys enthlt.
	 *
	 * @return Der "Emmissionskurs" des DepotEintrags als double
	 */
	public double getPriceIPO () {
		return m_dPriceIPO;
	}

	/**
	 * Setzt den Wert der Membervariable m_dPriceIPO, die den
	 * "Emmissionskurs" des DepotEntrys aufnimmt.
	 *
	 * @param dPriceIPO Der neue "Emmissionskurs" des DepotEintrags
	 */
	public void setPriceIPO (double dPriceIPO) {
		m_dPriceIPO = dPriceIPO;
	}

}
