/* Generated by Together */

package ap.data;

/**
 * Title:        Ametas StockService
 * Description:  Datenhaltungsklasse fr im Depot des Benutzeraccounts befindliche Aktie
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class CDepotEntry extends CBaseStock implements AMETAS.data.AMETASSendable, java.io.Serializable {

	/** Einige real-world-Membervariablen der Klasse */
	private double m_dPriceBought = 0.0;
	private int m_iAmount = 0;



	/**
	 * Konstruktor der Klasse, mit dem alle Membervariablen gesetzt werden knnen
	 *
	 * @param sName Der Name des Depoteintrags
	 * @param dPriceIPO Der Kaufpreis des Depoteintrags
	 * @param dPriceCurrent Der aktuelle Preis des Depoteintrags
	 * @param iAmount Die Anzahl der Aktien dieses Depoteintrags
	 */
	public CDepotEntry (String sName, double dPriceBought, double dPriceCurrent, int iAmount) {

		/* Den entsprechenden Eltern-Konstruktor aufrufen */
		super (sName, dPriceCurrent, 0.0);

		/* Aggregierte Attribute setzen */
		m_dPriceBought = dPriceBought;
		m_iAmount = iAmount;

	}

	/**
	 * Konstruktor der Klasse, der eine von getData() erzeugte Objektstruktur empfngt
	 * und in die Membervariablen eintrgt
	 *
	 * @param aobjData Das vierelementige Objekt-Array mit den Objekten Name, Kaufpreis,
	 * aktueller Preis sowie Menge, wie es von getData() erzeugt wird.
	 */
	public CDepotEntry (java.lang.Object[] aobjData) {

		/* Den entsprechenden Eltern-Konstruktor mit Dummywerten aufrufen */
		super ("", 0.0, 0.0);

		/* Attribute mit setData einlesen, dazu an Funktion setData() weiterleiten,
		um Coderedundanz zu vermeiden. */
		try {
		        setData(aobjData);
		} catch (java.lang.ClassCastException ex) {
		        /* do_nothing, die entsprechenden Membervariablen, die nach den
		        Fehler verursachenden auftraten, bleiben dann leer */
		}

	}

	/**
	 * Konstruktor der Klasse, der alle Membervariablen neutral belt
	 */
	public CDepotEntry () {

		/* Den entsprechenden Eltern-Konstruktor aufrufen */
		super ();

	}

	/**
	 * Liest die Parameter des Objektes aus einem Object-Array, das zuvor mit getData generiert
	 * wurde. So knnen die Membervariablen aus einer AMETAS-Nachricht ausgelesen und direkt in ein
	 * neues CDepotEntry-Objekt gesteckt werden.
	 *
	 * @param aobjData ein Object-Array, welches den neuen Zustand fr das Objekt enthlt. Dieses Array
	 * wird von der Methode getData generiert.
	 */
	public void setData(java.lang.Object[] aobjData) throws java.lang.ClassCastException {

		try {

		        /* Die Membervariablen aus dem Objekt-Array fllen */
		        m_sName = aobjData[0].toString();
		        m_dPriceBought = ((Double)aobjData[1]).doubleValue();
		        m_dPriceCurrent = ((Double)aobjData[2]).doubleValue();
		        m_iAmount = ((Integer)aobjData[3]).intValue();

		} catch (Exception ex) {

		        /* Beim Einlesen der Objekte trat eine falsche Klasse auf, die Anzahl der
			gelieferten Array-Elemente war zu klein (<4) oder ein anderer Fehler trat auf.
		        Das wird dem Aufrufer hier mittels einer ClassCastException mitgeteilt. */
		        throw new java.lang.ClassCastException("Ungltiges Format im bergebenen Objekt-Array.");

		}

	}

	/**
	 * Schreibt alle Membervariablen der CDepotEntry-Klasse als Java-Objekte in ein Object-Array
	 * und liefert dieses zurck. Das Object-Array kann dann in einer AMETAS-Nachricht verschickt
	 * werden und auf der Empfngerseite mit setData wieder in ein Objekt der gleichen Klasse
	 * gesteckt werden.
	 *
	 * @return das Object-Array mit den in Systemklassen (String, Double, Integer, etc.) gespeicherten
	 * Membervariablen
	 */
	public java.lang.Object[] getData() {

		/* Neues Objektarray der Lnge 4 (wir haben 4 Membervariablen, die
		zurcklieferbar sind) anlegen */
		Object[] aobjData = new Object[4];

		/* Objektarray mit den Objektreprsentationen der Membervariablen fllen */
		aobjData[0] = m_sName;
		aobjData[1] = new Double(m_dPriceBought);
		aobjData[2] = new Double(m_dPriceCurrent);
		aobjData[3] = new Integer(m_iAmount);

		/* geflltes Objektarray an Aufrufer zurck */
		return aobjData;

	}

	/**
	 * Liefert den Wert der Membervariable m_dPriceBought zurck, die den
	 * Kaufpreis des DepotEntrys enthlt.
	 *
	 * @return Der Kaufpreis des DepotEintrags als double
	 */
	public double getPriceBought () {
		return m_dPriceBought;
	}

	/**
	 * Setzt den Wert der Membervariable m_dPriceBought, die den
	 * Kaufpreis des DepotEntrys aufnimmt.
	 *
	 * @param dPriceBought Der neue Kaufpreis des DepotEintrags
	 */
	public void setPriceBought (double dPriceBought) {
		m_dPriceBought = dPriceBought;
	}

	/**
	 * Liefert den Wert der Membervariable m_iAmount zurck, die die
	 * Anzahl der Aktien des DepotEntrys enthlt.
	 *
	 * @return Der Anzahl der Aktien dieses DepotEintrags als int
	 */
	public int getAmount () {
		return m_iAmount;
	}

	/**
	 * Setzt den Wert der Membervariable m_iAmount, die die
	 * Anzahl der Aktien des DepotEntrys aufnimmt.
	 *
	 * @param iAmount Die neue Anzahl der Aktien dieses DepotEintrags
	 */
	public void setAmount (int iAmount) {
		m_iAmount = iAmount;
	}

	/**
	 * Liefert den Wert des Depoteintrags zum Zeitpunkt des Kaufs zurck
	 * (PriceBought * Amount).
	 *
	 * @return Der Wert des Depoteintrags zum Zeitpunkt des Kaufs
	 */
	public double getValueBought () {
		return (double)(m_iAmount * m_dPriceBought);
	}

	/**
	 * Liefert den aktuellen Wert des Depoteintrags zurck (PriceCurrent * Amount).
	 *
	 * @return Der aktuelle Wert des Depoteintrags
	 */
	public double getValueCurrent () {
		return (double)(m_iAmount * m_dPriceCurrent);
	}

}
