/* Generated by Together */

package ap.data;

import java.util.*;

/**
 * Title:        Ametas StockService
 * Description:  Datenhaltungsklasse fr eine im Service gehandelte Aktie
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class CStock extends CBaseStock implements java.io.Serializable {

	/**
	 * Konstruktor der Klasse, mit dem alle Membervariablen gesetzt werden knnen
	 *
	 * @param sName Das Namensattribut des anzulegenden Objekts
	 * @param dPriceCurrent Der aktuelle Preis des anzulegenden Objekts
	 * @param dPriceIPO Das Erffnungspreis des anzulegenden Objekts
	 */
	public CStock (String sName, double dPriceCurrent, double dPriceIPO) {

		/* Den entsprechenden Eltern-Konstruktor aufrufen */
		super (sName, dPriceCurrent, dPriceIPO);

	}

	/**
	 * Konstruktor der Klasse, mit dem alle Membervariablen 0 bzw. null bleiben
	 */
	public CStock () {

		/* Den entsprechenden Eltern-Konstruktor aufrufen */
		super ();

	}

	/**
	 * Methode liefert zurck, ob das Objekt noch gehandelt wird (sprich
	 * geerbte Membervariable m_dPriceCurrent != 0.0 ist)
	 *
	 * @return Liefert true zurck, wenn Aktie noch "gehandelt" wird, sonst false
	 */
	public boolean isTraded () {

		/* Boolean zurckgeben je nach Wert von m_dPriceCurrent */
		if (m_dPriceCurrent > 0.0) { return true; }
		else { return false; }

	}

	/**
	 * Methode berechnet den aktuellen Preis der Aktie nach der "Klausschen Formel"
	 * neu. Ist der aktuelle Kurs == 0.0, bedeutet das, dass die Aktie nicht mehr
	 * gehandelt wird und der Kurs verndert sich dementsprechend nicht mehr (bleibt
	 * bei 0.0).
	 *
	 * @param objRandom Ein Objekt vom Typ java.util.Random, dass Zufallszahlen liefer
	 * (wird von auen an die Funktion gegeben, um zufllige Kursschwankungen (Irrfahrt)
	 * zu erhalten).
	 */
	public void updatePrice (Random objRandom) {

		/* Differenz der Kursvernderung bestimmen (-1..+1) */
		double dDiff = objRandom.nextDouble()*2.0 - 1.0;

		/* Wenn Aktie noch gehandelt wird, dann Kurs verndern */
		if (isTraded()) {
			m_dPriceCurrent += dDiff;
		}

		/* berprfen, ob Kurs < 0.0 gesunken ist -> Firma Bankrott,
		dann auf 0.0 setzen, schlielich mu der Aktienbesitzer kein
		negatives Eigenkapital bezahlen*/
		if (m_dPriceCurrent < 0.0) {
		        m_dPriceCurrent = 0.0;
		}

	}

}
