package ap.data;

/**
 * Title:        Klasse CStockAgentMsg
 * Description:  abstrakte Basisklasse fr alle Datenhaltungsklassen der
 *               Optionen eines StockAgents
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public abstract class CStockAgentMsg implements AMETAS.data.AMETASSendable, java.io.Serializable {

        /**
         * Die genaue Uhrzeit, um die diese Nachricht entstanden ist
         */
        private java.util.Date m_dateTimeCreated = null;

        /**
         * Konstruktor der Klasse
         *
         */
        public CStockAgentMsg() {

                /* Fabian Wleklinski: Die aktuelle Uhrzeit und das aktuelle Datum merken */
                m_dateTimeCreated = new java.util.Date();
        }

        /**
         * Liefert das Datum und die Uhrzeit, zu der diese Nachricht erzeugt worden ist
         */
        public java.util.Date getTimeCreated() {
                return this.m_dateTimeCreated;
        }

        /**
         * Setzt das Datum und die Uhrzeit, zu dem diese Nachricht erzeugt worden ist
         * @param dateTimeCreated das Datum und die Uhrzeit, zu dem diese Nachricht erzeugt worden ist
         */
        public void setTimeCreated( java.util.Date dateTimeCreated ) {
                this.m_dateTimeCreated = dateTimeCreated;
        }

        /**
         * Die Funktion &quot;getData()&quot; ist abstrakt definiert, und muss daher von
         * allen abgeleiteten Klassen, die instanziiert werden sollen, berschrieben
         * werden. Sie dient dazu, die Informationen zur Verfgung zu stellen, die die
         * Funktion &quot;getData()&quot; aus der Klasse &quot;CStockAgentMsgs&quot;
         * bentigt.
         */
        public abstract Object[] getData();

        /**
         * Die Funktion &quot;setData()&quot; ist abstrakt definiert, und muss daher von
         * allen abgeleiteten Klassen, die instanziiert werden sollen, berschrieben
         * werden. Sie dient dazu, die Informationen einzulesen, die die
         * Funktion &quot;setData()&quot; aus der Klasse &quot;CStockAgentMsgs&quot;
         * liefert.
         */
        public abstract void setData( Object[] aobjData );

}
