package ap.data;

/**
 * Title:        Klasse CStockAgentMsgDepot
 * Description:  Nachricht von einem StockAgent an einen StockUA, der ihn ber
 *               die Entwicklung des Despots auf dem Laufenden hlt
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class CStockAgentMsgDepot extends CStockAgentMsg implements AMETAS.data.AMETASSendable{

        /**
         * Menge der Aktien im Depot des StockAgent
         */
        private CDepot m_depotStocks = null;

        public CStockAgentMsgDepot() {
        }

        /**
         * Konstruktor der Klasse
         * @param depotStocks das Depot des StockAgent
         */
        public CStockAgentMsgDepot( CDepot depotStocks ) {
                /* Fabian Wleklinski: Die bergebenen Parameter merken */
                this.m_depotStocks = depotStocks;
        }

        /**
         * Liefert das gesamte Depot des StockAgent zurck
         */
        public CDepot getDepot() {
                return this.m_depotStocks;
        }

        /**
         * Setzt das gesamte Depot auf das bergebene Depot
         */
        public void setDepot( CDepot depotStocks ) {
                this.m_depotStocks = depotStocks;
        }

        /**
         * Die Funktion &quot;getData()&quot; wird vom Interface &quot;AMETASSendable&quot;
         * gefordert. Sie dient dazu, im Falle einer Serialisierung der Klasse (bei einer
         * Migration des Agenten) alle enthaltenen Daten/Variablen/Members in generische
         * Objekte zu verwandeln.
         */
        public Object[] getData() {

                /* Fabian Wleklinski: Es muss ein Feld von generischen Objekten zurckgegeben
                werden, dies fordert das "AMETASSendable"-Interface. Dieses Feld wird nun
                erzeugt: */
                Object[] aobjData = new Object[ 1 ];

                /* Fabian Wleklinski: Nun alle Daten/Variablen/Members in dieses Feld
                schreiben: */
                aobjData[ 0 ] = this.m_depotStocks.getData();

                /* Fabian Wleklinski: Nun dieses Feld zurckgeben: */
                return aobjData;
        }

        /**
         * Die Funktion &quot;setData()&quot; wird vom Interface &quot;AMETASSendable&quot;
         * gefordert. Sie dient dazu, im Falle einer Serialisierung der Klasse (bei einer
         * Migration des Agenten) alle enthaltenen Daten/Variablen/Members aus generischen
         * Objekten zu lesen.
         */
        public void setData( Object[] aobjData ) {

                /* Fabian Wleklinski: Nun alle Daten/Variablen/Members aus dem
                bergebenen Feld lesen, und in die entsprechenden Variablen eintragen: */

                CDepot depotStocks = new CDepot();
                depotStocks.setData( (Object[]) aobjData[ 0 ] );

                this.m_depotStocks = depotStocks;
        }

}
