package ap.data;

/**
 * Title:        Ametas StockService
 * Description:  Von CDepot abgeleitete Klasse, mit der Summen von Depotwerten gespeichert werden
 *               knnen, was fr die Anzeige in der Bilanztabelle ntig ist.
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class CSumDepot extends CDepot {

	/** Die Membervariablen reprsentieren die Werte fr den aktuellen Gewinn/Verlust und
	den mit den aktuell gehaltenen Aktien realisierten Gewinn/Verlust */
	Double m_dGainCurrent = null;           // m_dTotalPriceCurrent - m_dTotalPriceBought
	Double m_dGainOverall = null;           // m_dAccountBalance + m_dTotalPriceBought

	/**
	 * Der Konstruktor des Summendepots
	 */
        public CSumDepot() {

		/* Elternklassenkonstruktor CDepot() aufrufen */
		super ();

        }

	/**
	 * Setzt den Gesamtkaufpreis aller im Depot verwalteten Aktien
	 */
	public void setTotalPriceBought (Double dTotalPriceBought) {
		m_dTotalPriceBought = dTotalPriceBought;
	}

	/**
	 * Setzt den aktuellen Gesamtwert der im Depot verwalteten Aktien
	 * -> Summe ber alle Aktientitel (Kurs des Aktientitels * Aktienanzahl)
	 */
	public void setTotalPriceCurrent (Double dTotalPriceCurrent) {
		m_dTotalPriceCurrent = dTotalPriceCurrent;
	}

	/**
	 * Setzt den mit den im Depot verwalteten Aktien erzielten Gewinn/Verlust
	 */
	/*public void setGainCurrent (Double dGainCurrent) {
		m_dGainCurrent = dGainCurrent;
	}*/

	/**
	 * Setzt den Gesamtgewinn/-verlust (m_dAccountBalance + m_dTotalPriceBought)
	 */
	/* public void setGainOverall (Double dGainOverall) {
		m_dGainOverall = dGainOverall;
	} */

	/**
	 * Setzt die Gesamtzahl der im Depot verwalteten Aktien (aktiven!)
	 */
	public void setTotalAmount (Integer iTotalAmount) {
		m_iTotalAmount = iTotalAmount;
	}

	/**
	 * Setzt die Tendenz des Depots (steigend, fallend, stagnierend :)
	 */
	public void setTendency (int iTendency) {
		m_iTendency = iTendency;
	}

}