package ap.stockua;

import java.util.Hashtable;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * Title:        Ametas StockService
 * Description:  Die "klassische" AboutBox :)
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class CAboutBox extends JDialog implements ActionListener {

        JPanel panel1 = new JPanel();
        JPanel panel2 = new JPanel();
        JPanel insetsPanel1 = new JPanel();
        JPanel insetsPanel2 = new JPanel();
        JButton button1 = new JButton();
        JLabel imageLabel = new JLabel();
        BorderLayout borderLayout1 = new BorderLayout();
        BorderLayout borderLayout2 = new BorderLayout();
        FlowLayout flowLayout1 = new FlowLayout();
        String product = "Ametas StockService";
        String version = "1.0";
        String copyright = "Copyright (c) 2001";
        String comments = "";
        JTextArea jTextArea1 = new JTextArea();
        JPanel panelContent = new JPanel();
        BorderLayout borderLayout3 = new BorderLayout();
        JPanel panelAuthorInfo = new JPanel();
        GridLayout gridLayout2 = new GridLayout();
        JLabel labelTitle = new JLabel();
        JLabel labelAuthors = new JLabel();
        JLabel labelCopyright = new JLabel();
        JLabel labelSpacing1 = new JLabel();

	/** Die verwendeten Bilder des Benutzeradapters werden in dieser Hashliste gehalten. */
	Hashtable m_hashImages = null;



	/**
	 * Der Konstruktor der Aboutbox empfngt auch den zentralen Bilderhash
	 */
        public CAboutBox(Frame parent, Hashtable hashImages) {

		/* Elternkonstruktor aufrufen */
                super(parent);

		/* Parameter in Membervariable eintragen */
		m_hashImages = hashImages;

                enableEvents(AWTEvent.WINDOW_EVENT_MASK);
                try {
                        jbInit();
                }
                catch(Exception e) {
                        e.printStackTrace();
                }
                pack();

        }

        /**Component initialization*/
        private void jbInit() throws Exception  {

		/* Oberflchenelemente konfigurieren und verknpfen */
                this.setTitle("Info");
                setResizable(false);
                panel1.setLayout(borderLayout1);
                panel2.setLayout(borderLayout2);
                insetsPanel1.setLayout(flowLayout1);
                insetsPanel2.setLayout(flowLayout1);
                insetsPanel2.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
                button1.setText("Ok");
                button1.addActionListener(this);
                jTextArea1.setWrapStyleWord(true);
                jTextArea1.setRows(5);
                jTextArea1.setLineWrap(true);
                jTextArea1.setOpaque(false);
                jTextArea1.setText("Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001");
                jTextArea1.setToolTipText("");
                panelContent.setLayout(borderLayout3);
                imageLabel.setIcon((ImageIcon)(m_hashImages.get("bean1")));
                panelAuthorInfo.setLayout(gridLayout2);
                gridLayout2.setRows(6);
                gridLayout2.setColumns(1);
                labelTitle.setToolTipText("");
                labelTitle.setText("Ametas StockUA");
                labelAuthors.setText("Martin Klossek, Fabian Wleklinski         ");
                labelCopyright.setText("Copyright (c) 2001");
                insetsPanel2.add(imageLabel, null);
                panel2.add(insetsPanel2, BorderLayout.WEST);
                this.getContentPane().add(panel1, null);
                panel2.add(panelContent, BorderLayout.CENTER);
                panelContent.add(jTextArea1, BorderLayout.CENTER);
                panelContent.add(panelAuthorInfo, BorderLayout.NORTH);
                panelAuthorInfo.add(labelSpacing1, null);
                panelAuthorInfo.add(labelTitle, BorderLayout.WEST);
                panelAuthorInfo.add(labelAuthors, BorderLayout.EAST);
                panelAuthorInfo.add(labelCopyright, null);
                insetsPanel1.add(button1, null);
                panel1.add(insetsPanel1, BorderLayout.SOUTH);
                panel1.add(panel2, BorderLayout.NORTH);

        }

        /**Overridden so we can exit when window is closed*/
        protected void processWindowEvent(WindowEvent e) {
                if (e.getID() == WindowEvent.WINDOW_CLOSING) {
                        cancel();
                }
                super.processWindowEvent(e);
        }

        /**Close the dialog*/
        void cancel() {
                dispose();
        }

        /**Close the dialog on a button event*/
        public void actionPerformed(ActionEvent e) {
                if (e.getSource() == button1) {
                        cancel();
                }
        }

}