package ap.stockua;

import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import ap.data.*;

/**
 * Title:        Ametas StockService
 * Description:  Diese Klasse beherbergt den Dialog zum Konfigurieren, Entsenden und Bearbeiten von Agenten
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class CAgentEditBox extends JDialog implements ActionListener, java.io.Serializable {

	/** Oberflchenelemente als private Membervariablen */
        JPanel panelMain = new JPanel();
        JPanel panelContent = new JPanel();
        JPanel panelButtons = new JPanel();
        JButton buttonOk = new JButton();
        BorderLayout borderLayoutPanelMain = new BorderLayout();
        JButton buttonCancel = new JButton();
        JPanel panelBasics = new JPanel();
        JLabel labelAgentName = new JLabel();
        JLabel labelPlaceName = new JLabel();
        GridLayout gridLayout1 = new GridLayout();
        TitledBorder titledBorder1;
        Border border1;
        JTextField textFieldAgentName = new JTextField();
        JButton buttonAgentName = new JButton();
        JTextField textFieldPlaceName = new JTextField();
        JButton buttonPlaceName = new JButton();
        JPanel jPanel1 = new JPanel();
        Border border2;
        TitledBorder titledBorder2;
        Border border3;
        ButtonGroup buttonGroupStrategy = new ButtonGroup();
        JRadioButton radioButtonStrategy1 = new JRadioButton();
        JRadioButton radioButtonStrategy2 = new JRadioButton();
        GridLayout gridLayout3 = new GridLayout();
        JPanel jPanel2 = new JPanel();
        JPanel jPanel3 = new JPanel();
        JPanel jPanel4 = new JPanel();
        BorderLayout borderLayout1 = new BorderLayout();
        JPanel jPanel5 = new JPanel();
        BorderLayout borderLayout2 = new BorderLayout();
        BorderLayout borderLayout3 = new BorderLayout();
        JPanel jPanel6 = new JPanel();
        JLabel labelStrategy1Param1 = new JLabel();
        JTextField textFieldStrategy1Param1 = new JTextField();
        Border border4;
        JTabbedPane jTabbedPane1 = new JTabbedPane();
        BorderLayout borderLayout4 = new BorderLayout();
        JPanel panelStrategy = new JPanel();
        JPanel panelBasis = new JPanel();
        Border border5;
        TitledBorder titledBorder3;
        BorderLayout borderLayout5 = new BorderLayout();
        Border border6;
        BorderLayout borderLayout6 = new BorderLayout();
        BorderLayout borderLayout7 = new BorderLayout();
        JPanel panelActivities = new JPanel();
        BorderLayout borderLayout8 = new BorderLayout();
        JPanel jPanel7 = new JPanel();
        GridLayout gridLayout2 = new GridLayout();
        JButton jButton1 = new JButton();
        JButton jButton3 = new JButton();
        JLabel labelUserName = new JLabel();
        JLabel labelAccountBalance = new JLabel();
        JPanel jPanel8 = new JPanel();
        JTextField textFieldUserName = new JTextField();
        BorderLayout borderLayout9 = new BorderLayout();
        BorderLayout borderLayout10 = new BorderLayout();
        JTextField textFieldAccountBalance = new JTextField();
        JPanel jPanel9 = new JPanel();
        JLabel labelAgentDollar = new JLabel();
        GridLayout gridLayout4 = new GridLayout();
        JLabel labelStrategy1Param2 = new JLabel();
        JTextField textFieldStrategy1Param2 = new JTextField();
        JLabel labelStrategy2Param2 = new JLabel();
        JLabel labelStrategy2Param1 = new JLabel();
        JTextField textFieldStrategy2Param2 = new JTextField();
        JTextField textFieldStrategy2Param1 = new JTextField();
        JPanel jPanel10 = new JPanel();
        GridLayout gridLayout5 = new GridLayout();
        JLabel jLabel1 = new JLabel();
        JLabel jLabel2 = new JLabel();
        JLabel labelStrategy1Param3 = new JLabel();
        JTextField textFieldStrategy1Param3 = new JTextField();
        JLabel labelStrategy1Param4 = new JLabel();
        JTextField textFieldStrategy1Param4 = new JTextField();
        JLabel labelStrategy2Param3 = new JLabel();
        JTextField textFieldStrategy2Param3 = new JTextField();

	/** Liste von Namen, die beim Drcken auf den Random-Button zufllig ausgespuckt werden :) */
	String[] m_asPresetNames = new String[] {
		"Stefanie",
		"Alexandra",
		"Melanie",
		"Tina",
		"Silke",
		"Katrin",
		"Katharina",
		"Monika",
		"Petra",
		"Roberta",
		"Heike",
		"Elisabeth",
		"Doris",
		"Tine",
		"Agnes",
		"Julia",
		"Britta",
		"Ups!",
		"Silvia",
		"Michaela",
		"Sina",
		"Jessica",
		"Jenny",
		"Corinna",
		"Jennifer",
		"Anke",
		"Schranke",
		"Wurstbrot",
		"Andrea",
		"Sabine",
		"Maja",
		"Sara",
		"Dorothea",
		"Maria",
		"Ivette",
		"Eva",
		"Susi",
		"Susanne",
		"Nathalie",
		"Elke",
		"Moehre",
		"Evangelia",
		"Sandra",
		"Sigrit",
		"Christina",
		"Martina",
		"Cornelia",
		"Olivia",
		"Nina",
		"Ruth",
		"Trina",
		"Anika",
		"Angelika",
		"Nina",
		"Marina",
		"Victoria"
	};

	/** Zufallszahlengenerator */
	Random m_objRandom = null;

	/** Membervariable nimmt den Modus des Dialogs auf ("new", "edit") */
	String m_sMode = "";

	/** Membervariable nimmt das Datenhaltungsobjekt auf, aus dem und in das
	die Daten der Controls bertragen werden. */
	CStockAgentWrapper m_objStockAgentWrapper = null;

	/** ber diese Membervariable vom Typ Hashtable wird ein Nachrichtenaustausch
	zwischen dem aufrufenden Frame und dem Dialog ermglicht. Insbesondere die Hash-
	Eintrge "action" => "cancel|new|change|sendchanges|end" und "error" => "null|Fehlermeldung" */
	Hashtable m_hashMessages = null;

	/** Die verwendeten Bilder des Benutzeradapters werden in dieser Hashliste gehalten. */
	Hashtable m_hashImages = null;



	/**
	 * Der Konstruktor, der neben dem Elternframe auch Konfigurationsdaten bernimmt.
	 * Nimmt den Operationsmodus des Dialogs in sMode entgegen ("new" = Neuen Agent anlegen,
	 * "edit" = Laufenden Agenten ndern) und speichert ein entsprechendes Datenhaltungsobjekt.
	 */
        public CAgentEditBox(Frame parent, String sMode, CStockAgentWrapper objWrapper, Hashtable hashMessages, Hashtable hashImages) {

		/* Elternkonstruktor aufrufen (einen mit der gleichen Signatur gibt es ja nicht!) */
                super(parent);

		/* bertrgt die Parameter in die Membervariablen */
		m_sMode = sMode;
		m_objStockAgentWrapper = objWrapper;
		m_hashMessages = hashMessages;
		m_hashImages = hashImages;

		/* den Zufallszahlengenerator initialisieren */
		m_objRandom = new Random();

		/* GUI aufbauen und "zusammenpacken" */
                enableEvents(AWTEvent.WINDOW_EVENT_MASK);
                try {
                        jbInit();
                } catch(Exception e) {
                        e.printStackTrace();
                }
                pack();

        }

        /**
	 * Component initialization
	 */
	private void jbInit() throws Exception  {

		/* GUI-Elemente initialisieren und konfigurieren. Das ist grtenteils JBuilder-Output. */
		if (m_sMode.equals("new")) {
                        this.setTitle("Neuen Agenten konfigurieren");
		} else {
                        this.setTitle("Agent " + m_objStockAgentWrapper.getAgentName() + " konfigurieren");
		}

                titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Basiseinstellungen");
                border1 = BorderFactory.createCompoundBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Basiseinstellungen"),BorderFactory.createEmptyBorder(3,4,4,4));
                border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
                titledBorder2 = new TitledBorder(border2,"Strategieeinstellungen");
                border3 = BorderFactory.createCompoundBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Strategieeinstellungen"),BorderFactory.createEmptyBorder(3,4,4,4));
                border4 = BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(3,4,4,4));
                border5 = BorderFactory.createEmptyBorder();
                titledBorder3 = new TitledBorder(border5,"Basiseinstellungen");
                border6 = BorderFactory.createEmptyBorder(3,3,3,3);
                panelMain.setLayout(borderLayoutPanelMain);
                panelContent.setLayout(borderLayout5);
                buttonOk.setActionCommand("button_ok");
                buttonOk.addActionListener(this);
		if (m_sMode.equals("new")) { buttonOk.setText("Agent aussenden"); } else { buttonOk.setText("Einstellungen speichern"); }
                buttonCancel.setActionCommand("button_cancel");
		buttonCancel.addActionListener(this);
                buttonCancel.setText("Abbrechen");
                labelAgentName.setText("Agentenname:");
                labelPlaceName.setText("Stelle:");
                panelBasics.setLayout(gridLayout1);
                gridLayout1.setRows(4);
                gridLayout1.setColumns(2);
                gridLayout1.setHgap(4);
                gridLayout1.setVgap(4);
                panelBasics.setBorder(border1);
                buttonAgentName.setToolTipText("Zuflligen Agentennamen generieren");
                buttonAgentName.setActionCommand("buttonAgentName");
                buttonAgentName.setIcon((ImageIcon)(m_hashImages.get("tipoftheday")));
                buttonAgentName.addActionListener(this);
                buttonPlaceName.setToolTipText("Zielstelle auswhlen");
                buttonPlaceName.setActionCommand("buttonPlaceName");
                buttonPlaceName.setIcon((ImageIcon)(m_hashImages.get("zoom")));
                buttonPlaceName.addActionListener(this);
                jPanel1.setBorder(border3);
                jPanel1.setLayout(gridLayout3);
                radioButtonStrategy1.setText("Strategie 1");
                radioButtonStrategy2.setEnabled(false);
                radioButtonStrategy2.setText("Strategie 2");
                gridLayout3.setRows(2);
                gridLayout3.setColumns(2);
                jPanel4.setLayout(borderLayout1);
                jPanel5.setLayout(borderLayout2);
                jPanel2.setLayout(borderLayout3);
                labelStrategy1Param1.setToolTipText("Bei Erreichen dieses Wertes (von oben) wird eine Aktie aus dem Depot " +
    "veruert (Agentendollar).");
                labelStrategy1Param1.setText("Notfallverkauf:");

                jPanel6.setBorder(border4);
                jPanel6.setLayout(gridLayout4);
                jPanel3.setLayout(borderLayout4);
                panelStrategy.setBorder(BorderFactory.createEmptyBorder());
                panelStrategy.setLayout(borderLayout7);
                panelContent.setBorder(border6);
                panelBasis.setLayout(borderLayout6);
                panelActivities.setLayout(borderLayout8);
                jPanel7.setLayout(gridLayout2);
                jButton1.setIcon((ImageIcon)(m_hashImages.get("killagent")));
                jButton1.setText("Agent beenden");
                gridLayout2.setRows(3);
                gridLayout2.setColumns(1);
                jButton3.setIcon((ImageIcon)(m_hashImages.get("changeagent")));
                jButton3.setText("Agentenstrategie ndern");
                labelUserName.setText("Benutzername:");
                labelAccountBalance.setText("Kontostand:");
                jPanel8.setLayout(borderLayout9);
                jPanel9.setLayout(borderLayout10);

		if (m_sMode.equals("edit")) {

	                textFieldAgentName.setText(m_objStockAgentWrapper.getAgentName());
                        textFieldPlaceName.setText(m_objStockAgentWrapper.getPlaceName());

	                textFieldAccountBalance.setText(""+m_objStockAgentWrapper.getDepot().getAccountBalance());
		        textFieldAccountBalance.setEnabled(false);
		        textFieldUserName.setEnabled(false);
		        textFieldAgentName.setEnabled(false);
		        buttonAgentName.setEnabled(false);

		        // 2001-02-12: z. Z. gibt es nur eine Strategie
		        radioButtonStrategy1.setSelected(true);

		        try {
			        double[] adParams = m_objStockAgentWrapper.getStrategyParams();
	        	        textFieldStrategy1Param1.setText("" + adParams[0]);
	                        textFieldStrategy1Param2.setText("" + adParams[1]);
	                        textFieldStrategy1Param3.setText("" + adParams[2]);
	                        textFieldStrategy1Param4.setText("" + adParams[3]);
		        } catch (Exception ex) {
				JOptionPane.showMessageDialog(this, "Die Parameterdaten fr die Strategie konnten nicht in die Felder eingetragen werden.", "Fehler", JOptionPane.ERROR_MESSAGE);
		        }

		} else {

	                textFieldAgentName.setText("");
                        textFieldPlaceName.setText("");

	                textFieldAccountBalance.setText("1000.00");
                        radioButtonStrategy1.setSelected(true);

		        textFieldStrategy1Param1.setText("-3.00");
	                textFieldStrategy1Param2.setText("1.00");
	                textFieldStrategy1Param3.setText("-1.00");
                        textFieldStrategy1Param4.setText("0.75");

		}

		textFieldUserName.setText(""+m_objStockAgentWrapper.getUserName());
                labelAgentDollar.setToolTipText("");
                labelAgentDollar.setText("  Agentendollar");
                gridLayout4.setRows(4);
                gridLayout4.setColumns(2);
                gridLayout4.setHgap(4);
                gridLayout4.setVgap(4);
                labelStrategy1Param2.setToolTipText("Bei Erreichen dieses Wertes (von unten) wird eine Aktie aus dem Depot " +
    "veruert (Agentendollar).");
                labelStrategy1Param2.setText("Verkauf:");
                textFieldStrategy1Param2.setToolTipText("");
                labelStrategy2Param2.setEnabled(false);
                labelStrategy2Param2.setText("Parameter 2");
                labelStrategy2Param1.setEnabled(false);
                labelStrategy2Param1.setText("Parameter 1");
                textFieldStrategy2Param2.setEnabled(false);
                textFieldStrategy2Param2.setText("15.00");
                textFieldStrategy2Param1.setEnabled(false);
                textFieldStrategy2Param1.setText("10.00");
                jPanel10.setLayout(gridLayout5);
                jPanel10.setEnabled(false);
                jPanel10.setBorder(border4);
                gridLayout5.setRows(3);
                gridLayout5.setColumns(2);
                gridLayout5.setHgap(4);
                gridLayout5.setVgap(4);
                jLabel1.setText(" ");
                jLabel2.setText(" ");
                labelStrategy1Param3.setToolTipText("Bei Erreichen dieses Wertes (von oben) wird eine Aktie gekauft (Agentendollar).");
                labelStrategy1Param3.setText("Kauf:");
                labelStrategy1Param4.setToolTipText("Relativer Anteil des zu investierenden Geldes am gesamten Geldbestand " +
    "(0..1)");
                labelStrategy1Param4.setText("Geldanteil:");
                textFieldStrategy1Param4.setToolTipText("Relativer Anteil des zu investierenden Geldes am gesamten Geldbestand " +
    "(0..1)");
                labelStrategy2Param3.setEnabled(false);
                labelStrategy2Param3.setText("Parameter 3");
                textFieldStrategy2Param3.setEnabled(false);
                textFieldStrategy2Param3.setText("2.00");
                this.getContentPane().add(panelMain, null);
                panelButtons.add(buttonOk, null);
                panelButtons.add(buttonCancel, null);
                panelMain.add(panelButtons, BorderLayout.SOUTH);
                panelMain.add(panelContent, BorderLayout.CENTER);
                panelContent.add(jTabbedPane1, BorderLayout.CENTER);
                panelStrategy.add(jPanel1, BorderLayout.NORTH);
                jPanel1.add(radioButtonStrategy1, null);
                jPanel1.add(jPanel2, null);
                jPanel2.add(jPanel6, BorderLayout.NORTH);
                jPanel6.add(labelStrategy1Param1, null);
                jPanel6.add(textFieldStrategy1Param1, null);
                jPanel6.add(labelStrategy1Param2, null);
                jPanel6.add(textFieldStrategy1Param2, null);
                jPanel6.add(labelStrategy1Param3, null);
                jPanel6.add(textFieldStrategy1Param3, null);
                jPanel6.add(labelStrategy1Param4, null);
                jPanel6.add(textFieldStrategy1Param4, null);
                jPanel2.add(jLabel1, BorderLayout.SOUTH);
                jPanel1.add(radioButtonStrategy2, null);
                jPanel1.add(jPanel3, null);
                jPanel3.add(jPanel10, BorderLayout.NORTH);
                jPanel10.add(labelStrategy2Param1, null);
                jPanel10.add(textFieldStrategy2Param1, null);
                jPanel10.add(labelStrategy2Param2, null);
                jPanel10.add(textFieldStrategy2Param2, null);
                jPanel10.add(labelStrategy2Param3, null);
                jPanel10.add(textFieldStrategy2Param3, null);
                jPanel3.add(jLabel2, BorderLayout.SOUTH);
                panelBasis.add(panelBasics, BorderLayout.NORTH);
                panelBasics.add(labelAgentName, null);
                panelBasics.add(jPanel4, null);
                jPanel4.add(textFieldAgentName, BorderLayout.CENTER);
                jPanel4.add(buttonAgentName, BorderLayout.EAST);
                panelBasics.add(labelPlaceName, null);
                panelBasics.add(jPanel5, null);
                jPanel5.add(textFieldPlaceName, BorderLayout.CENTER);
                jPanel5.add(buttonPlaceName, BorderLayout.EAST);
                panelBasics.add(labelUserName, null);
                panelBasics.add(jPanel8, null);
                jPanel8.add(textFieldUserName, BorderLayout.CENTER);
                panelBasics.add(labelAccountBalance, null);
                panelBasics.add(jPanel9, null);
                jPanel9.add(textFieldAccountBalance, BorderLayout.CENTER);
                jPanel9.add(labelAgentDollar, BorderLayout.EAST);
                jTabbedPane1.add(panelBasis, "Einstellungen");
                jTabbedPane1.add(panelStrategy, "Strategie");
		// if (m_sMode.equals("edit")) { jTabbedPane1.add(panelActivities, "Aktionen"); }
                panelActivities.add(jPanel7, BorderLayout.NORTH);
                jPanel7.add(jButton3, null);
                jPanel7.add(jButton1, null);
                buttonGroupStrategy.add(radioButtonStrategy1);
                buttonGroupStrategy.add(radioButtonStrategy2);

                jTabbedPane1.setSelectedComponent(panelBasis);

        }

	/**
	 * Setzt den Operationsmodus des Dialogs ("new" = Neuen Agent anlegen,
	 * "edit" = Laufenden Agenten ndern) und bergibt ein entsprechendes Datenhaltungsobjekt
	 */
	public void setOperationMode (String sMode, CStockAgentWrapper objWrapper) {

		/* bertrgt die Parameter in die Membervariablen */
		m_sMode = sMode;
		m_objStockAgentWrapper = objWrapper;

	}

        /**
	 * Overridden so we can exit when window is closed
	 */
        protected void processWindowEvent(WindowEvent e) {

                if (e.getID() == WindowEvent.WINDOW_CLOSING) {
                        cancel();
                }
                super.processWindowEvent(e);

        }

        /**
	 * Close the dialog
	 */
        void cancel() {

		/* Message fr aufrufenden Frame setzen */
		m_hashMessages.put ("action", "cancel");

		/* Dialog killen und Modalzustand beenden (falls Dialog modal war!) */
                dispose();

        }

        /**
	 * Close the dialog on a button event
	 */
        public void actionPerformed(ActionEvent e) {

		/* Reaktion auf den Ok-Button */
                if (e.getSource() == buttonOk) {

		        if (m_sMode.equals("new")) {

				/* Die Instanz von CStockAgentWrapper zum Datenaustausch mit der aufrufenden
				Klasse verndern, wenn diese nicht leer ist! */
				if (m_objStockAgentWrapper != null) {

					/* die Felder aus dem Basiseinstellungen-Reiter auf Validitt prfen. */
				        if (textFieldAgentName.getText().equals("")) {
						JOptionPane.showMessageDialog(this, "Bitte geben Sie eine Namen fr den Agenten im Feld Agentenname ein.", "Fehler", JOptionPane.ERROR_MESSAGE);
						return;
				        }
				        if (textFieldPlaceName.getText().equals("")) {
						JOptionPane.showMessageDialog(this, "Bitte geben Sie eine gltigen Wert in das Feld Zielstelle ein.", "Fehler", JOptionPane.ERROR_MESSAGE);
						return;
				        }
				        if (textFieldUserName.getText().equals("")) {
						JOptionPane.showMessageDialog(this, "Bitte geben Sie eine Namen fr den Benutzer im Feld Benutzername ein.", "Fehler", JOptionPane.ERROR_MESSAGE);
						return;
				        }
				        Double dAccountBalance = null;
				        try {
						String sRawAccountBalance = textFieldAccountBalance.getText().replace(',','.');
						dAccountBalance = new Double (sRawAccountBalance);
				        } catch (Exception ex) {
						JOptionPane.showMessageDialog(this, "Bitte geben Sie eine gltige Dezimalzahl in das Feld Kontostand ein.", "Fehler", JOptionPane.ERROR_MESSAGE);
						return;
				        }

				        /* Als nchstes mssen wir die Werte aus dem Reiter Strategieeinstellungen auslesen */
				        double[] adParams = null;
					if (radioButtonStrategy1.isSelected()) {
						try {
							adParams = new double[4];
	        				        adParams[0] = new Double(textFieldStrategy1Param1.getText().replace(',','.')).doubleValue();
		        	                        adParams[1] = new Double(textFieldStrategy1Param2.getText().replace(',','.')).doubleValue();
	        	                                adParams[2] = new Double(textFieldStrategy1Param3.getText().replace(',','.')).doubleValue();
	                                                adParams[3] = new Double(textFieldStrategy1Param4.getText().replace(',','.')).doubleValue();
						} catch (Exception ex) {
						        JOptionPane.showMessageDialog(this, "Bitte geben Sie gltige Fliekommazahlen in die Parameterfelder von Strategie 1 ein.", "Fehler", JOptionPane.ERROR_MESSAGE);
							return;
						}
				        }

				        /* Wenn keine Validittsfehler auftreten, dann Werte in Struktur schreiben */
					m_objStockAgentWrapper.setAgentName(textFieldAgentName.getText());
					m_objStockAgentWrapper.setPlaceName(textFieldPlaceName.getText());
				        m_objStockAgentWrapper.setUserName(textFieldUserName.getText());
					m_objStockAgentWrapper.getDepot().setAccountBalance (dAccountBalance);
				        m_objStockAgentWrapper.setStrategyParams (adParams);

				        /* Message fr aufrufenden Frame setzen */
				        m_hashMessages.put ("action", "new");

				}

		        } else if (m_sMode.equals("edit")) {

				/* Die Instanz von CStockAgentWrapper zum Datenaustausch mit der aufrufenden
				Klasse verndern, wenn diese nicht leer ist! */
				if (m_objStockAgentWrapper != null) {

					/* das Feld Stellenname aus dem Basiseinstellungen-Reiter auf Validitt prfen. */
				        if (textFieldPlaceName.getText().equals("")) {
						JOptionPane.showMessageDialog(this, "Bitte geben Sie eine gltigen Wert in das Feld Zielstelle ein.", "Fehler", JOptionPane.ERROR_MESSAGE);
						return;
				        }

				        /* Als nchstes mssen wir die Werte aus dem Reiter Strategieeinstellungen auslesen */
				        double[] adParams = null;
					if (radioButtonStrategy1.isSelected()) {
						try {
							adParams = new double[4];
	        				        adParams[0] = new Double(textFieldStrategy1Param1.getText().replace(',','.')).doubleValue();
		        	                        adParams[1] = new Double(textFieldStrategy1Param2.getText().replace(',','.')).doubleValue();
	        	                                adParams[2] = new Double(textFieldStrategy1Param3.getText().replace(',','.')).doubleValue();
	                                                adParams[3] = new Double(textFieldStrategy1Param4.getText().replace(',','.')).doubleValue();
						} catch (Exception ex) {
						        JOptionPane.showMessageDialog(this, "Bitte geben Sie gltige Fliekommazahlen in die Parameterfelder von Strategie 1 ein.", "Fehler", JOptionPane.ERROR_MESSAGE);
							return;
						}
				        }

				        /* Wenn keine Validittsfehler auftreten, dann Werte in Struktur schreiben */
				        m_hashMessages.put ("placename", textFieldPlaceName.getText());
				        m_hashMessages.put ("strategyid", new Integer(1));
				        m_hashMessages.put ("strategyparams", adParams);

				        /* Message fr aufrufenden Frame setzen */
				        m_hashMessages.put ("action", "change");

				}

		        }

		        /* den Dialog schlieen */
                        dispose();

                } else if (e.getSource() == buttonCancel) {

		        /* den Dialog schlieen */
		        cancel();

		} else if (e.getSource() == buttonAgentName) {

		        /* Neuen Zufallsnahmen in textFieldAgentName eintragen  */
		        int i = m_objRandom.nextInt (m_asPresetNames.length);
		        textFieldAgentName.setText (m_asPresetNames[i]);

		} else if (e.getSource() == buttonPlaceName) {

		        /* neues Hash fr die Kommunikation mit dem Dialog anlegen */
		        Hashtable hashMessages = new Hashtable();

		        /* Dialog fr die schnelle Auswahl einer Stelle ffnen */
                        CPlaceSelectBox dlg = new CPlaceSelectBox(null, m_objStockAgentWrapper.getPlaceName(), hashMessages);
	                Dimension dlgSize = dlg.getPreferredSize();
                        Dimension frmSize = getSize();
                        Point loc = getLocation();
	                dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
                        dlg.setModal(true);

		        /* Dialog ausfhren und bis Ausfhrungsende warten */
                        dlg.show();

		        /* Dialogrckgabe ber Kommunikationshash auswerten und im Erfolgsfall neuen Stellennamen setzen */
			if (hashMessages.get("action") != null) {
	        	        if (((String)hashMessages.get("action")).equals("newplacename")) {

				        if (hashMessages.get("placename") != null) {
						textFieldPlaceName.setText ((String)(hashMessages.get("placename")));
				        }

	        	        }
		        }


		}

        }

}