package ap.stockua;

import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import javax.swing.JTree;
import javax.swing.tree.*;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;

import ap.data.*;

/**
 * Title:        Ametas StockService
 * Description:  Diese Klasse beherbergt den Dialog zum Auswhlen einer Zielstelle
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class CPlaceSelectBox extends JDialog implements ActionListener {

	/** Oberflchenelemente als private Membervariablen */
        JPanel panelMain = new JPanel();
        JPanel panelContent = new JPanel();
        JPanel panelButtons = new JPanel();
        JButton buttonOk = new JButton();
        BorderLayout borderLayoutPanelMain = new BorderLayout();
        JButton buttonCancel = new JButton();
        TitledBorder titledBorder1;
        Border border1;
        Border border2;
        TitledBorder titledBorder2;
        Border border3;
        ButtonGroup buttonGroup1 = new ButtonGroup();
        Border border4;
        Border border5;
        TitledBorder titledBorder3;
        BorderLayout borderLayout5 = new BorderLayout();
        Border border6;
	JTree m_treePlaces;

	/** Membervariable nimmt den Modus des Dialogs auf ("new", "edit") */
	String m_sMode = "";

	/** Membervariable nimmt den initialen Stellennamen auf */
	String m_sPlaceName = "";

	/** ber diese Membervariable vom Typ Hashtable wird ein Nachrichtenaustausch
	zwischen dem aufrufenden Frame und dem Dialog ermglicht. Insbesondere die Hash-
	Eintrge "action" => "cancel|new|change|sendchanges|end" und "error" => "null|Fehlermeldung" */
	Hashtable m_hashMessages = null;
        JPanel panelPlaceNameTree = new JPanel();
        BorderLayout borderLayout1 = new BorderLayout();



	/**
	 * Der Konstruktor, der neben dem Elternframe auch Konfigurationsdaten bernimmt.
	 * Nimmt ein Nachrichtenhash (hashMessages) entgegen fr den Datenaustausch mit dem
	 * aufrufenden Frame.
	 *
	 * @param sPlaceName der Name der zu selektierenden Stelle
	 * @param hashMessages Hash fr den Nachrichtenaustausch
	 */
        public CPlaceSelectBox(Frame parent, String sPlaceName, Hashtable hashMessages) {

		/* Elternkonstruktor aufrufen (einen mit der gleichen Signatur gibt es ja nicht!) */
                super(parent);

		/* bertrgt die Parameter in die Membervariablen */
		m_sPlaceName = sPlaceName;
		m_hashMessages = hashMessages;

		/* GUI aufbauen und "zusammenpacken" */
                enableEvents(AWTEvent.WINDOW_EVENT_MASK);
                try {
                        jbInit();
                } catch(Exception e) {
                        e.printStackTrace();
                }
                pack();

        }

        /**
	 * Component initialization
	 */
	private void jbInit() throws Exception  {

		/* GUI-Elemente initialisieren und konfigurieren. Das ist grtenteils JBuilder-Output. */
                this.setTitle("Zielstelle auswhlen");

                titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Basiseinstellungen");
                border1 = BorderFactory.createCompoundBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Basiseinstellungen"),BorderFactory.createEmptyBorder(3,4,4,4));
                border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
                titledBorder2 = new TitledBorder(border2,"Strategieeinstellungen");
                border3 = BorderFactory.createCompoundBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Strategieeinstellungen"),BorderFactory.createEmptyBorder(3,4,4,4));
                border4 = BorderFactory.createLineBorder(SystemColor.controlText,1);
                border5 = BorderFactory.createEmptyBorder();
                titledBorder3 = new TitledBorder(border5,"Basiseinstellungen");
                border6 = BorderFactory.createEmptyBorder(3,3,3,3);
                panelMain.setLayout(borderLayoutPanelMain);
                panelContent.setLayout(borderLayout5);

                buttonOk.setActionCommand("button_ok");
                buttonOk.setText("Stelle auswhlen");
                buttonOk.addActionListener(this);
		buttonOk.setEnabled(false);
                buttonCancel.setActionCommand("button_cancel");
		buttonCancel.addActionListener(this);
                buttonCancel.setText("Abbrechen");

                panelContent.setBorder(border6);
                panelPlaceNameTree.setLayout(borderLayout1);
                this.getContentPane().add(panelMain, null);
                panelButtons.add(buttonOk, null);
                panelButtons.add(buttonCancel, null);
                panelMain.add(panelButtons, BorderLayout.SOUTH);
                panelMain.add(panelContent, BorderLayout.CENTER);
                panelContent.add(panelPlaceNameTree, BorderLayout.CENTER);

		/* Aufbauen der Baumstruktur nach Ametas-PNS */
		DefaultMutableTreeNode tnTop = new DefaultMutableTreeNode("cs.uniffm.de");
		DefaultMutableTreeNode tnPract = new DefaultMutableTreeNode("praktikum");
		tnTop.add (tnPract);
		DefaultMutableTreeNode tnGroupOrange = new DefaultMutableTreeNode("orange");
		DefaultMutableTreeNode tnGroupBlue = new DefaultMutableTreeNode("blau");
		DefaultMutableTreeNode tnGroupBrown = new DefaultMutableTreeNode("braun");
		tnPract.add (tnGroupOrange);
		tnPract.add (tnGroupBlue);
		tnPract.add (tnGroupBrown);

		/* Die einzelnen Stellen hinzufgen -> das sollte besser automatisch ber den PNS gehen! */
		tnGroupOrange.add (new DefaultMutableTreeNode("stelle-1"));
		tnGroupOrange.add (new DefaultMutableTreeNode("stelle-2"));
		tnGroupOrange.add (new DefaultMutableTreeNode("stelle-3"));
		tnGroupOrange.add (new DefaultMutableTreeNode("stelle-4"));
		tnGroupBlue.add (new DefaultMutableTreeNode("stelle-1"));
		tnGroupBlue.add (new DefaultMutableTreeNode("stelle-2"));
		tnGroupBlue.add (new DefaultMutableTreeNode("stelle-3"));
		tnGroupBlue.add (new DefaultMutableTreeNode("stelle-4"));
		tnGroupBrown.add (new DefaultMutableTreeNode("stelle-1"));
		tnGroupBrown.add (new DefaultMutableTreeNode("stelle-2"));
		tnGroupBrown.add (new DefaultMutableTreeNode("stelle-3"));
		tnGroupBrown.add (new DefaultMutableTreeNode("stelle-4"));

		// Create a tree that allows one selection at a time.
		m_treePlaces = new JTree(tnTop);
		m_treePlaces.getSelectionModel().setSelectionMode (TreeSelectionModel.SINGLE_TREE_SELECTION);
		m_treePlaces.putClientProperty("JTree.lineStyle", "Angled");
		JScrollPane treeView = new JScrollPane(m_treePlaces);
                panelPlaceNameTree.add (treeView, BorderLayout.CENTER);

		/* Aufklappen der Nodes */
		TreePath objThisPath = null;
		objThisPath = new TreePath(new Object[] { tnTop, tnPract, tnGroupOrange });
		m_treePlaces.expandPath(objThisPath);
		/* DEBUG: objThisPath = new TreePath(new Object[] { tnTop, tnPract, tnGroupBlue });
		m_treePlaces.expandPath(objThisPath); */

		/* Listen for when the selection changes. */
		m_treePlaces.addTreeSelectionListener (new TreeSelectionListener() {
		        public void valueChanged(TreeSelectionEvent e) {
				tree_selectionPerformed(e);
		        }
		});

                m_treePlaces.addMouseListener(new java.awt.event.MouseAdapter() {
                        public void mouseClicked(MouseEvent e) {
                                treeView_mouseClicked(e);
                        }
                });

        }

        /**
	 * Overridden so we can exit when window is closed
	 */
        protected void processWindowEvent(WindowEvent e) {

                if (e.getID() == WindowEvent.WINDOW_CLOSING) {
                        cancel();
                }
                super.processWindowEvent(e);

        }

        /**
	 * Close the dialog
	 */
        void cancel() {

		/* Message fr aufrufenden Frame setzen */
		m_hashMessages.put ("action", "cancel");

		/* Dialog killen und Modalzustand beenden (falls Dialog modal war!) */
                dispose();

        }

        /**
	 * Close the dialog on a button event
	 */
        public void actionPerformed(ActionEvent e) {

		/* Reaktion auf den Ok-Button */
                if (e.getSource() == buttonOk) {

		        /* Ziel: Das selektierte Blatt (falls!) als vollqualifizierten Stellennamen zurckgeben */
		        String sPlaceName = getPlaceName ();;

		        /* Aktionsvariable im Hash setzen, wenn sPlaceName != "" */
		        if (!sPlaceName.equals("")) {
			        m_hashMessages.put ("placename", sPlaceName);
		                m_hashMessages.put ("action", "newplacename");
		        } else {
		                m_hashMessages.put ("action", "cancel");
		        }

		        /* den Dialog schlieen */
                        dispose();

                } else if (e.getSource() == buttonCancel) {

		        /* Abbruch in der Aktionsvariable fr aufrufenden Frame anzeigen */
		        m_hashMessages.put ("action", "cancel");

		        /* den Dialog schlieen */
		        cancel();

		}

        }

	/**
	 * Methode versucht den vollstndigen Stellennamen eines selektierten Blattes zu bestimmen. Wurde
	 * gar nichts oder ein innerer Knoten markiert, wird ein Leerstring zurckgeliefert.
	 */
	private String getPlaceName () {

		/* den selektierten Node ermitteln und berprfen */
		DefaultMutableTreeNode node = (DefaultMutableTreeNode)m_treePlaces.getLastSelectedPathComponent();
		if (node == null) {

			/* Kein Node selektiert, dann wird kein Stellenname zurckgegeben */
			return "";

	        } else {

			/* Nur ein Blatt kann eine Stelle sein, alles andere sind "subdomains" im pns-system */
			if (!node.isLeaf()) {

			        /* Node ist kein Blatt, also auch keine Stelle, daher leer zurck */
			        return "";

			} else {

			        /* Name des Blattes = Name der Stelle holen */
        	                String sPlaceName = (String)node.getUserObject();

			        /* solange durchlaufen, bis an Wurzel gestoen und dabei den vollstndigen Stellennamen zusammensetzen */
			        DefaultMutableTreeNode nodeCurrent = node;
				while (nodeCurrent.getParent() != null) {
					nodeCurrent = (DefaultMutableTreeNode)nodeCurrent.getParent();
					sPlaceName =  sPlaceName + "." + (String)nodeCurrent.getUserObject();
			        }

			        return sPlaceName;

			}
		}
	}

	/**
	 * Der Eventhandler wird aufgerufen, wenn eine Selektion im Baum vorgenommen wurde
	 */
        public void tree_selectionPerformed(TreeSelectionEvent e) {

		/* den selektierten Node holen */
		DefaultMutableTreeNode node = (DefaultMutableTreeNode)m_treePlaces.getLastSelectedPathComponent();

		/* wenn der Benutzer alle Nodes deselektiert hat, dann finden wir hier auch keinen
		selektierten Node. Der ok-Button wird deaktiviert. */
		if (node == null) {
		        buttonOk.setEnabled(false);
		        return;
		}

		/* Wurde ein selektierter Node gefunden, dann zwischen Blatt und innerem Knoten unterscheiden.
		Erstere stellen sinnvolle Nodes da, die eine ametas-stelle beschreiben. */
		if (node.isLeaf()) {
		        buttonOk.setEnabled(true);
		} else {
		        buttonOk.setEnabled(false);
		}

	}

	/**
	 * Der Eventhandler reagiert auf Mausklicks in den m_treePlace
	 */
        void treeView_mouseClicked(MouseEvent e) {

		/* Bei Doppelklick auf ein Blatt wird der vollstndige Stellenname erzeugt
		und zum aufrufenden Frame zurckgesprungen. */
		if (e.getClickCount() >= 2) {

		        /* Ziel: Das selektierte Blatt (falls!) als vollqualifizierten Stellennamen zurckgeben */
		        String sPlaceName = getPlaceName ();;

		        /* Aktionsvariable im Hash setzen, wenn sPlaceName != "" */
		        if (!sPlaceName.equals("")) {
			        m_hashMessages.put ("placename", sPlaceName);
		                m_hashMessages.put ("action", "newplacename");

			        /* den Dialog schlieen */
                                dispose();
		        }

		}

        }

}