package ap.stockua;

import javax.swing.UIManager;
import java.awt.*;

/**
 * Title:        Ametas StockService
 * Description:  Applikation fr GUI-Tests des Benutzeradapters
 * Copyright:    Copyright (c) 2001
 * Company:      Ametas Praktikum, Uni Frankfurt, Fachbereich Biologie und Informatik, WS2000/2001
 * @author Martin Klossek, Fabian Wleklinski
 * @version 1.0
 */

public class StockGUITestApp implements java.io.Serializable {

	boolean packFrame = false;

	/**
	 * Construct the application
	 */
        public StockGUITestApp() {

                CMainFrame frame = new CMainFrame(null);

                /* Validate frames that have preset sizes Pack frames that have
		useful preferred size info, e.g. from their layout */
                if (packFrame) {
                        frame.pack();
                }
                else {
                        frame.validate();
                }

                /* Center the window */
                Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                Dimension frameSize = frame.getSize();
                if (frameSize.height > screenSize.height) {
                        frameSize.height = screenSize.height;
                }
                if (frameSize.width > screenSize.width) {
                        frameSize.width = screenSize.width;
                }
                frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
                frame.setVisible(true);

        }

        /**
	 * Main method
	 */
	public static void main(String[] args) {

		try {
		        UIManager.LookAndFeelInfo[] plafs = UIManager.getInstalledLookAndFeels();
		        String sClassName = UIManager.getSystemLookAndFeelClassName();
		        for (int i = 0; i < plafs.length; i++) {
				sClassName = plafs[i].getClassName();
				// DEBUG: Ausgeben der LnF-Klassennamen: System.out.println(sClassName);
		        }

		        // DEBUG: System-LnF setzen: UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		        UIManager.setLookAndFeel(plafs[0].getClassName());
		}
		catch(Exception e) {
		        e.printStackTrace();
		}

                new StockGUITestApp();

        }

}